****f*SuSeFLAV/runslha.f 
* Program : SuSeFLAV: Supersymmetry seesaw and flavor violation calculator
* Version : 1.0
* Website : http://cts.iisc.ernet.in/Suseflav/main.html
* Authors : Debtosh Choudhury  debtosh@cts.iisc.ernet.in 
*           Raghuveer Garani   rgarani@cts.iisc.ernet.in
*           Sudhir Vempati     vempati@cts.iisc.ernet.in
*  NAME
*    Program runonce
*  SYNOPSIS
*    Main program to compute spectrum at a single point for SuSeFLAV. 
*  FUNCTION
*     
*  INPUTS
*    Inputs read from sinput.in
*    tanbeta  -- ratio of vevs, input at msusy scale 
*   
*  RESULT
*    
*  EXAMPLE
*    ----
*  NOTES
*  
*  BUGS
*    ---
*  SEE ALSO
*    -----
******
* You can use this space for remarks that should not be included
* in the documentation.
C****C  
C===================================================================================
C\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
C     1. This will give result for a single point in the parameter space.
C     2. Checked on 10/05/2010.
C     
C     
C\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
      

      Program runslha

      IMPLICIT NONE 

      INTEGER rhn, errge

      DOUBLE PRECISION m0,m12,m10,m20, sgnmu,prnstat_r
      double precision tanbeta,a0,ue3,Mtpole,MR1,MR2,MR3
      double precision Ynui(3,3),Mbpole,Mtaupole

      integer lopt, prnstat

      character*1 quit
      character*3 case 
      CHARACTER*4 model
      INTEGER input
      real tstart(2),tstop(2)            
      double precision total              ! For receiving total time

C--------------------------------------------------------------------------- 
      DOUBLE PRECISION Mg1,Mg2,Mg3
      DOUBLE PRECISION mq11,mq12,mq13,mq21,mq22,mq23,mq31,mq32,mq33 
      DOUBLE PRECISION mu11,mu12,mu13,mu21,mu22,mu23,mu31,mu32,mu33 
      DOUBLE PRECISION md11,md12,md13,md21,md22,md23,md31,md32,md33 
      DOUBLE PRECISION ml11,ml12,ml13,ml21,ml22,ml23,ml31,ml32,ml33 
      DOUBLE PRECISION me11,me12,me13,me21,me22,me23,me31,me32,me33 
      DOUBLE PRECISION mnu11,mnu12,mnu13,mnu21,mnu22,mnu23,mnu31,mnu32,
     $     mnu33 

      integer ii,num,modnum,smnum(10),minparnum(10),counter_sminp
      integer counter_minpar,counter_algopar,algonum(20)
      double precision sminp(10), minpar(10), algopar(20)
      double precision alph,gf,alphas,spectol,rhn_r
      DOUBLE PRECISION runloops, rhnmix
      character*100 mr3er,filepath
C---GMSB

      DOUBLE PRECISION gmsbsusyb, gmsbmess,gr,nhat

!--------------------------------------      
      common/sminputs/ mbpole, mtaupole, Mtpole
      common/loops/ lopt,rhn
      common/mssminputs/ m0, m12, m10, m20, sgnmu, tanbeta, a0
      common/mssmrhn/ MR1,MR2,MR3,ue3, Ynui
      common/charinputs/case, model
      common/gauge/alph,Gf,alphas
      common/gmsbinputs/ gmsbsusyb, gmsbmess,gr,nhat
C----------------SLHA common blocks-   

      common/slha_modsel/num, modnum

      common/slha_counters/counter_sminp,counter_minpar,counter_algopar
      common/slha_num/smnum,minparnum,algonum
      common/slha_variables/sminp,minpar,algopar
      common/ptolerance/spectol

C---------------------------------------
      EXTERNAL SuSeFLAV,readslha
C------------------------------------


C     ----------------------------------------------------------------
C     INPUTS -  read from init# files
C     ----------------------------------------------------------------
      quit = 'F'

       filepath = 'slha.in'  

       input=666


       OPEN(input, FILE=filepath)!,FORM='FORMATTED')

      call readslha(input)


!------inputs read from slha --> program variables
C  Modsel
      if(num.eq.1.and.modnum.eq.0)then
         model = 'mSUG'
      endif

      if(num.eq.1.and.modnum.eq.1)then
         model = 'GMSB'
      endif

      if(num.eq.1.and.modnum.eq.2)then
         model = 'NUHM'
      endif

C sm inputs

      sminpblock: do ii=1,counter_sminp     
      
      if(smnum(ii).eq.1) alph = 1/sminp(ii)
      if(smnum(ii).eq.2) Gf = sminp(ii)
      if(smnum(ii).eq.3) alphas = sminp(ii)
      if(smnum(ii).eq.5) mbpole = sminp(ii)
      if(smnum(ii).eq.6) mtpole = sminp(ii)
      if(smnum(ii).eq.7) mtaupole = sminp(ii)

      enddo sminpblock
C  minpar

      BCmsugra: if(model.eq.'mSUG')then
      minparblock: do ii = 0, counter_minpar

      if(minparnum(ii).eq.1) m0 =  minpar(ii)
      if(minparnum(ii).eq.2) m12 =  minpar(ii)
      if(minparnum(ii).eq.3) tanbeta =  minpar(ii)
      if(minparnum(ii).eq.4) sgnmu =  minpar(ii)
      if(minparnum(ii).eq.5) a0 =  minpar(ii)

          enddo minparblock
      endif BCmsugra


      BCmgmsb: if(model.eq.'GMSB')then
      minparblock1: do ii = 0, counter_minpar

      if(minparnum(ii).eq.1) gmsbsusyb =  minpar(ii)
      if(minparnum(ii).eq.2) gmsbmess =  minpar(ii)
      if(minparnum(ii).eq.3) tanbeta =  minpar(ii)
      if(minparnum(ii).eq.4) sgnmu =  minpar(ii)
      if(minparnum(ii).eq.5) nhat =  minpar(ii)
      if(minparnum(ii).eq.6) gr =  minpar(ii)

          enddo minparblock1
      endif BCmgmsb

      BCnuhm: if(model.eq.'NUHM')then
      minparblock2: do ii = 0, counter_minpar

      if(minparnum(ii).eq.1) m0 =  minpar(ii)
      if(minparnum(ii).eq.2) m12 =  minpar(ii)
      if(minparnum(ii).eq.3) tanbeta =  minpar(ii)
      if(minparnum(ii).eq.4) sgnmu =  minpar(ii)
      if(minparnum(ii).eq.5) a0 =  minpar(ii)
      if(minparnum(ii).eq.6) m10 =  minpar(ii)
      if(minparnum(ii).eq.7) m20 =  minpar(ii)

          enddo minparblock2
      endif BCnuhm


C algorithm parameters
     
      sflavalgo: do ii = 1, counter_algopar

      if(algonum(ii).eq.1) spectol = algopar(ii)

      if(algonum(ii).eq.2)then
         rhn_r = algopar(ii)
         if(rhn_r.eq.1.d0) rhn = 1
         if(rhn_r.eq.0.d0) rhn = 0
         endif

      if(algonum(ii).eq.3)then
         prnstat_r = algopar(ii)
         if(prnstat_r.eq.1.d0) prnstat = 1
         if(prnstat_r.eq.0.d0) prnstat = 0
         endif


      if(algonum(ii).eq.4) rhnmix = algopar(ii)

      if(rhnmix.eq.1.d0) case = 'CKM'
      if(rhnmix.eq.2.d0) case = 'MNS'
      if(rhnmix.eq.3.d0) case = 'USD'


          
      if(algonum(ii).eq.5) runloops = algopar(ii)
      
      if(runloops.eq.1.d0) lopt = 1
      if(runloops.eq.2.d0) lopt = 2

      if(algonum(ii).eq.6) ue3 = algopar(ii)
      if(algonum(ii).eq.7) MR1 = algopar(ii)
      if(algonum(ii).eq.8) MR2 = algopar(ii)
      if(algonum(ii).eq.9) MR3 = algopar(ii)

      if(algonum(ii).eq.10) Ynui(1,1)= algopar(ii)
      if(algonum(ii).eq.11) Ynui(1,2)= algopar(ii)
      if(algonum(ii).eq.12) Ynui(1,3)= algopar(ii)
      if(algonum(ii).eq.13) Ynui(2,1)= algopar(ii)
      if(algonum(ii).eq.14) Ynui(2,2)= algopar(ii)
      if(algonum(ii).eq.15) Ynui(2,3)= algopar(ii)
      if(algonum(ii).eq.16) Ynui(3,1)= algopar(ii)
      if(algonum(ii).eq.17) Ynui(3,2)= algopar(ii)
      if(algonum(ii).eq.18) Ynui(3,3)= algopar(ii)

      enddo sflavalgo
!-----------------

      wrinp1:if(rhn.ne.1.and.rhn.ne.0)then
         write(*,*)'=========================='
         write(*,*) 'Wrong input, rhn(either 0 or 1)'
         write(*,*)'=========================='       
         quit = 'T'
         endif wrinp1

         wrinp2:if(prnstat.ne.1.and.prnstat.ne.0)then
         write(*,*)'=========================='
         write(*,*) 'Wrong input, prnstat(either 0 or 1)',prnstat
         write(*,*)'=========================='       
         quit = 'T'                 
         endif wrinp2
         wrinp3:if(case.ne.'CKM'.and.case.ne.'MNS'
     $     .and.case.ne.'USD')then
         write(*,*)'=========================='
         write(*,*) 'Wrong input, rhn mixing'
         write(*,*)'=========================='       
         quit = 'T'
         endif wrinp3

      
         wrinp4:if(lopt.ne.1.and.lopt.ne.2)then
            write(*,*)'=========================='
            write(*,*) 'Wrong input, number of loops'
            write(*,*)'=========================='       
            quit = 'T'
         endif wrinp4

 !-------------------------

      if(model.eq.'GMSB'.and.rhn.eq.1)then

         if(gmsbsusyb/gmsbmess.gt.1.d0)then

            mr3er = " lambda/messenger should be less than 1"
            print*,"========================="
            print*, mr3er
            print*," Program aborted"
            print*,"=========================="
            quit = 'T'
            endif

         if(MR3.ge.gmsbmess)then
            mr3er = " Error: Messenger scale lesser than seesaw scale"
            print*,"========================="
            print*, mr3er
            print*," Program aborted"
            print*,"=========================="
            quit = 'T'                    
         ENDIF

      endif


      open(999,FILE='../tmp/output.txt',status='replace')
      if(prnstat.eq.1)then
         open(10,FILE='suseflav.out',access='append',status='replace')
         endif

!-----------------------------------------------------------------------------
      
!      total = ETIME(tstart) !<----- time counter
      
!-----------------------------------------------------------------------------



      if(model.eq.'mSUG')then

         m10 = m0
         m20 = m0

         mq11 = m0
         mq12 = 0.d0
         mq13 = 0.d0
         mq21 = 0.d0
         mq22 = m0
         mq23 = 0.d0
         mq31 = 0.d0
         mq32 = 0.d0
         mq33 = m0

         mu11 = m0
         mu12 = 0.d0
         mu13 = 0.d0
         mu21 = 0.d0
         mu22 = m0
         mu23 = 0.d0
         mu31 = 0.d0
         mu32 = 0.d0
         mu33 = m0

         md11 = m0
         md12 = 0.d0
         md13 = 0.d0
         md21 = 0.d0
         md22 = m0
         md23 = 0.d0
         md31 = 0.d0
         md32 = 0.d0
         md33 = m0

         ml11 = m0
         ml12 = 0.d0
         ml13 = 0.d0
         ml21 = 0.d0
         ml22 = m0
         ml23 = 0.d0
         ml31 = 0.d0
         ml32 = 0.d0
         ml33 = m0

         me11 = m0
         me12 = 0.d0
         me13 = 0.d0
         me21 = 0.d0
         me22 = m0
         me23 = 0.d0
         me31 = 0.d0
         me32 = 0.d0
         me33 = m0

         mnu11 = m0
         mnu12 = 0.d0
         mnu13 = 0.d0
         mnu21 = 0.d0
         mnu22 = m0
         mnu23 = 0.d0
         mnu31 = 0.d0
         mnu32 = 0.d0
         mnu33 = m0
         
         Mg1 = m12
         Mg2 = m12
         Mg3 = m12

      elseif(model.eq.'NUHM')then


         mq11 = m0
         mq12 = 0.d0
         mq13 = 0.d0
         mq21 = 0.d0
         mq22 = m0
         mq23 = 0.d0
         mq31 = 0.d0
         mq32 = 0.d0
         mq33 = m0

         mu11 = m0
         mu12 = 0.d0
         mu13 = 0.d0
         mu21 = 0.d0
         mu22 = m0
         mu23 = 0.d0
         mu31 = 0.d0
         mu32 = 0.d0
         mu33 = m0

         md11 = m0
         md12 = 0.d0
         md13 = 0.d0
         md21 = 0.d0
         md22 = m0
         md23 = 0.d0
         md31 = 0.d0
         md32 = 0.d0
         md33 = m0

         ml11 = m0
         ml12 = 0.d0
         ml13 = 0.d0
         ml21 = 0.d0
         ml22 = m0
         ml23 = 0.d0
         ml31 = 0.d0
         ml32 = 0.d0
         ml33 = m0

         me11 = m0
         me12 = 0.d0
         me13 = 0.d0
         me21 = 0.d0
         me22 = m0
         me23 = 0.d0
         me31 = 0.d0
         me32 = 0.d0
         me33 = m0

         mnu11 = m0
         mnu12 = 0.d0
         mnu13 = 0.d0
         mnu21 = 0.d0
         mnu22 = m0
         mnu23 = 0.d0
         mnu31 = 0.d0
         mnu32 = 0.d0
         mnu33 = m0
         
         Mg1 = m12
         Mg2 = m12
         Mg3 = m12
         
         
c$$$         elseif(model.eq.'NUGM')then
c$$$
c$$$         m10 = m0
c$$$         m20 = m0
c$$$
c$$$         mq11 = m0
c$$$         mq12 = 0.d0
c$$$         mq13 = 0.d0
c$$$         mq21 = 0.d0
c$$$         mq22 = m0
c$$$         mq31 = 0.d0
c$$$         mq32 = 0.d0
c$$$         mq33 = m0
c$$$
c$$$         mu11 = m0
c$$$         mu12 = m0
c$$$         mu13 = m0
c$$$         mu21 = m0
c$$$         mu22 = m0
c$$$         mu23 = m0
c$$$         mu31 = m0
c$$$         mu32 = m0
c$$$         mu33 = m0
c$$$
c$$$         md11 = m0
c$$$         md12 = m0
c$$$         md13 = m0
c$$$         md21 = m0
c$$$         md22 = m0
c$$$         md23 = m0
c$$$         md31 = m0
c$$$         md32 = m0
c$$$         md33 = m0
c$$$
c$$$         ml11 = m0
c$$$         ml12 = m0
c$$$         ml13 = m0
c$$$         ml21 = m0
c$$$         ml22 = m0
c$$$         ml23 = m0
c$$$         ml31 = m0
c$$$         ml32 = m0
c$$$         ml33 = m0
c$$$
c$$$         me11 = m0
c$$$         me12 = m0
c$$$         me13 = m0
c$$$         me21 = m0
c$$$         me22 = m0
c$$$         me23 = m0
c$$$         me31 = m0
c$$$         me32 = m0
c$$$         me33 = m0
c$$$
c$$$         mnu11 = m0
c$$$         mnu12 = m0
c$$$         mnu13 = m0
c$$$         mnu21 = m0
c$$$         mnu22 = m0
c$$$         mnu23 = m0
c$$$         mnu31 = m0
c$$$         mnu32 = m0
c$$$         mnu33 = m0
c$$$         
c$$$
c$$$         elseif(model.eq.'CNUM')then
c$$$            continue
         endif

        
         if(quit.eq.'F')then

       call SuSeFLAV(prnstat,mq11,mq12,mq13,mq21,mq22,mq23,
     $     mq31,mq32,mq33,mu11,mu12,mu13,mu21,mu22,mu23,mu31,mu32,
     $     mu33,md11,md12,md13,md21,md22,md23,md31,md32,md33,
     $     ml11,ml12,ml13,ml21,ml22,ml23,ml31,ml32,ml33, 
     $     me11,me12,me13,me21,me22,me23,me31,me32,me33 ,
     $     mnu11,mnu12,mnu13,mnu21,mnu22,mnu23,mnu31,mnu32,mnu33,
     $     Mg1,Mg2,Mg3,errge)

         elseif(quit.eq.'T')then
            print*,'Wrong inputs'
            endif


         close(999)

      if(prnstat.eq.1)then
         close(10)
         endif
     
!      total = etime(tstop)
!      write(6,901) total
 901  format(' USER STATE CPU TIME',f6.2,' SECONDS')
      
      END 
      
!===============================================================================
