C	Contains the Standard Inputs.	
C	Recompile completely whenever you change any one of the inputs. 
C	--------------------------------------------------------------
C	The values are defined at M_Z and are consistent with the 
C	paper of Fusaoka and Koide, Phys.Rev.D57:3986-4001,1998, Table V. 
C	The CKM matrix is defined as : 
C	
C		|  0.9756   0.2194   0.0031 |
C	VCKM =  | -0.2194   0.9748   0.0389 |
C		|  0.0055  -0.0387   0.9992 |
C	
C	--------------------------------------------------------------
	
	double precision MW, MZ, sinsqtw, pi
	double precision mE, mMU, mUQ, mC, mD, mS
	double precision VCKM(3,3),Vud,Vus,Vub,Vcd,Vcs,Vcb 
	double precision Vtd,Vts,Vtb,th12,th23,th13
	double precision UPMNS(3,3),CL(3,3)
	
C	MW = 80.33d0
	MW = 80.398d0
	MZ = 91.1876d0

!-------------------------------------------------------------------------------	
!	MASSES OF THE FERMIONIC PARTICLES	
!-------------------------------------------------------------------------------

	muq =  2.49d0*10.d0**(-3.d0)           !pdg2010
	mC  =  1.27d0                          !pdg2010


	mD  =  5.05d0*10.d0**(-3.d0)           !pdg2010
	mS  =  101.d0*10.d0**(-3.d0)           !pdg2010

	mE  =  5.0267d0*10.d0**(-4.d0)
	mMU =  1.05d0*10.d0**(-1.d0)	
!---------------------------------------------------------------------------	
!	ANGLES AND CKM MATRICES
!---------------------------------------------------------------------------	

	th12 = dASin(0.2272d0)
	th23 = dASin(0.04221d0)
	th13 = dASin(0.003959d0)

	Vud = dCos(th12)*dCos(th13)
	Vus = dSin(th12)*dCos(th13)
	Vub = dSin(th13) 

	Vcd = - dSin(th12)*dCos(th23) - dCos(th12)*dSin(th23)
     .	*dSin(th13)
	Vcs = dCos(th12)*dCos(th23) - dSin(th12)*dSin(th23)*dSin(th13)
	Vcb = dCos(th13)*dSin(th23)

	Vtd = dSin(th12)*dSin(th23)- dCos(th12)*dCos(th23)*dSin(th13)
	Vts = -dCos(th12)*dSin(th23)-dSin(th12)*dCos(th23)*dSin(th13) 
	Vtb = dCos(th23)*dCos(th13)

	VCKM(1,1) = Vud
	VCKM(1,2) = Vus
	VCKM(1,3) = Vub

	VCKM(2,1) = Vcd
	VCKM(2,2) = Vcs
	VCKM(2,3) = Vcb

	VCKM(3,1) = Vtd
	VCKM(3,2) = Vts
	VCKM(3,3) = Vtb


c$$$	VCKM(1,1) = 1.d0
c$$$	VCKM(1,2) = 0.d0
c$$$	VCKM(1,3) = 0.d0
c$$$
c$$$	VCKM(2,1) = 0.d0
c$$$	VCKM(2,2) = 1.d0
c$$$	VCKM(2,3) = 0.d0
c$$$
c$$$	VCKM(3,1) = 0.d0
c$$$	VCKM(3,2) = 0.d0
c$$$	VCKM(3,3) = 1.d0

	
!---------------------------------------------------------------------------	
! 	PMNS MATRIX	
!--------------------------------------------------------------------------
	pi = dacos(-1.d0)


	UPMNS(1,1) =  0.901381d0
	UPMNS(1,2) =  0.438763d0
	UPMNS(1,3) =  0.0707107d0
	UPMNS(2,1) = -0.353553d0
	UPMNS(2,2) =  0.612372d0
	UPMNS(2,3) =  0.707107d0
	UPMNS(3,1) =  0.266951d0
	UPMNS(3,2) = -0.662372d0
	UPMNS(3,3) =  0.707107d0

!--------------------------------------------------------------------------
!       C_l matrix
!-------------------------------------------------------------------------

	CL(1,1) = 17.d0/10.d0
	CL(1,2) = 1.d0/2.d0
	CL(1,3) = 3.d0/2.d0

	CL(2,1) = 3.d0/2.d0
	CL(2,2) = 3.d0/2.d0
	CL(2,3) = 1.d0/2.d0

	CL(3,1) = 2.d0
	CL(3,2) = 2.d0
	CL(3,3) = 0.d0

!-----------------------------------------------------------------------








